//http://seta43.hol.es/electro.html
//xsetaseta@gmail.com
//Libreria RF24master J. Coliz <maniacbug@ymail.com>
// Llave Codigo operacion 
//26/02/2018

//#define DEBUG 

#define NUMEROLLAVE  15
byte CODIGO2;

#define DIGIE  2  //Seleccion pin pulsador


#include <SPI.h> 
#include <nRF24L01.h>
#include <RF24.h>

#define CE 8
#define CSN 7

RF24 radio(CE, CSN);

const uint64_t tuberia = 0xE8E8F0F0E1LL;
byte dato[10];
int time1;
bool done;

byte x,y;
unsigned int codigo;

void setup() 
{     
  Serial.begin(9600);
  Serial.println("___LLAVE Codigo___");
  radio.begin();
  radio.setChannel(50);  
  radio.openReadingPipe(1, tuberia); 
  radio.startListening(); 

  CODIGO2=0;
  pinMode(3, INPUT);
  pinMode(4, INPUT);
  pinMode(5, INPUT);
  pinMode(6, INPUT);
  delay(100);
  if(digitalRead(3)) CODIGO2|=1;
  if(digitalRead(4)) CODIGO2|=2; 
  if(digitalRead(5)) CODIGO2|=4; 
  if(digitalRead(6)) CODIGO2|=8;

  Serial.println(CODIGO2);  
}


void loop(void)
{ 
  delay(1);
  time1++;

  if(time1>4000)
  {
    time1=0;
    radio.openReadingPipe(1, tuberia); 
    radio.startListening(); 
  }

  if(digitalRead(DIGIE))
  {
    Serial.println("Pulsado Boton de Apertura");
    radio.stopListening();
    radio.openWritingPipe(tuberia);
    delay(300);
    dato[0]=NUMEROLLAVE; //Numero de llave
    dato[1]=0;
    dato[2]=1;    //Codigo peticion de apertura 1
    dato[3]=0;
    dato[4]=0;
    enviarS();    
    delay(30);
    radio.openReadingPipe(1, tuberia); 
    radio.startListening(); 
  }


 while(radio.available()) 
  {
    radio.read(dato, 7);               
    done=1;  
  }

  if (done)
  { 
   #ifdef DEBUG
    Serial.print("CODIGO_L ");  
    Serial.print(dato[0]);     Serial.print("  "); 
    Serial.print(dato[1]);     Serial.print("  ");
    Serial.print(dato[2]);     Serial.print("  ");
    Serial.print(dato[3]);     Serial.print("  ");
    Serial.print(dato[4]);     Serial.println("  ");
   #endif
    if( 0==dato[0] && NUMEROLLAVE==dato[1] && 1==dato[2])  //Respuesta a pregunta
    {
       Serial.println("Respuesta a la pregunta");
       radio.stopListening();
       radio.openWritingPipe(tuberia);
       delay(100);       
       dato[0]=NUMEROLLAVE;//Numero de llave 
       dato[1]=0; 
       dato[2]=3;    
                   //Codigo respuesta       
       x=dato[3];  y=dato[4];
       codigo=x*y*CODIGO2+CODIGO2;
       x= codigo & 0xFF;
       y= codigo>>8 & 0xFF;
       dato[3]=x;  //codigo x
       dato[4]=y;  //codigo y
       enviarS();
       delay(3000);
       radio.openReadingPipe(1, tuberia); 
       radio.startListening();
       goto salto; 
    }
salto:    
   done=0;
  } 

}


void enviarS()
{
  radio.write(dato, 7); 
  delay(10);
}





